unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, TeeProcs, TeCanvas;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TMyBaseTree = class(TCustomTeePanelExtended)
  private
	  IBounds2D: TRect;
  protected
    procedure InternalDraw(const UserRectangle: TRect); override;
    function Rectangle2DPosition(const ARect: TRect): TRect;
  public
    constructor Create(AOwner:TComponent); override;
  end;
var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TMyBaseTree.InternalDraw(const UserRectangle: TRect);
var Old: Boolean;
    Str: String;
    ARect: TRect;
begin
	Old := AutoRepaint;
	AutoRepaint := false;

	PanelPaint(UserRectangle);
	ReCalcWidthHeight();

	InternalCanvas.Projection(100, ChartBounds, ChartBounds);
	Canvas.ClipRectangle(ChartBounds);

	IBounds2D := Rectangle2DPosition(ChartBounds);

	Str := 'This is a test';
	Canvas.RotateLabel3D(UserRectangle.Left + 200, UserRectangle.Top + 100, 0, Str, 0);

	Canvas.Brush.Style := bsClear;

	ARect := Rect(UserRectangle.left + 200, UserRectangle.Top + 100, UserRectangle.left + 400, UserRectangle.Top + 300);
	Canvas.RectangleWithZ(ARect, 0);
	AutoRepaint := Old;
end;

function TMyBaseTree.Rectangle2DPosition(const ARect: TRect): TRect;
var l, t, r, b: Integer;
begin
  l := ARect.Left;
  t := ARect.top;
  r := ARect.Right;
  b := ARect.bottom;

  Canvas.Calculate2DPosition(l, t, 0);
	Canvas.Calculate2DPosition(r, b, 0);

  result:= Rect(l, t, r, b);
end;

constructor TMyBaseTree.Create(AOwner:TComponent);
begin
  inherited;

	Align := alClient;
	Color := clWhite;
end;

var pTree: TMyBaseTree;

procedure TForm1.FormCreate(Sender: TObject);
begin
	pTree := TMyBaseTree.Create(Self);
	pTree.Parent := Self;
	pTree.Show();

  TrackBar1.Max:=500;
  TrackBar1.Min:=10;
  TrackBar1.Position:=100;
  TrackBar1.Frequency:=10;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  pTree.View3DOptions.Zoom := TrackBar1.Position;
  Label1.Caption:='Zoom: ' + IntToStr(TrackBar1.Position);
end;

end.
